#include"main.h"
/***************************************************************************
    "SVT" Phillip Blair's Spanish Vocabulary Tutor 
    Copyright (C) 1997  Phillip Vaughn Blair
    phillip_blair@writeme.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**************************************************************************/

void practise_nouns(void)
{
   unsigned long int rand_no;
   unsigned long int database_size;
   datum key,found_content;
   int counter;
   FILE *num_stream;
   char num_file_path[405];
   char span_in[40];
   frame *f1;
      
   database_size = get_database_size();
   /*okay, so let's make up our temporary database */
   open_database_formods();
   for(counter = 0; counter < 10;counter++)
     {
	rand_no = rand() / (RAND_MAX / database_size + 1);
	/*'kay..get the corresponding database entry*/

	key.dptr=(char*)&rand_no;
	key.dsize=(int)sizeof(rand_no);

	found_content = gdbm_fetch(dbfchkvar,key);
	if(found_content.dptr == NULL)
	  {
	     move(17,10);
	     addstr("could not find a piece of data ");
	     move(18,10);
	     addstr("something's gone terribly wrong recently...");
	     refresh();
	     sleep(2);
	     exit(EXIT_FAILURE);
	  }
	
	

	/* assign our found content to a unit of data(a structure)*/
	f1 = ((frame*)found_content.dptr);/*what the %^&*! is this? it works! kids don't try this at home!*/
	/*now normally we would examine it here,but let's defer that to v2.0 */



	/*practise the noun (or whatever)*/
	
	erase();
	refresh();
	move(9,10);
	addstr("what is ");
	addstr(f1->english);
	addstr(" ?");
	refresh();
	get_lne(10,10,span_in,20);
	/*validate it*/
	if(!(strcmp(span_in,f1->spanish)))
	  {
	     /*in other words if they're equal,*/
	     move(17,10);
	     addstr("correct");
	     refresh();
	     sleep(1);
	     move(17,10);
	     addstr("       ");
	     refresh();
	     running_total++;
	     f1->right++;
	     f1->ltiwa = running_total;
	  }
	else
	  {
	     /*or if they're not*/
	     move(17,10);
	     addstr("wrong!");
	     move(18,10);
	     addstr("it's ");
	     addstr(f1->spanish);
	     refresh();
	     sleep(1);
	     erase();
	     refresh();
	     running_total++;
	     f1->wrong++;
	     f1->ltiwa = running_total;
	  }
	
	
	
	

	/* question administered,we can write the results back to disk */
	
	if(gdbm_store(dbfvar,key,found_content,GDBM_REPLACE))
	  {
	     move(17,10);
	     addstr("problem writing into our nouns database");
	     move(18,10);
	     addstr("something's gone terribly wrong recently...");
	     refresh();
	     sleep(2);
	     exit(EXIT_FAILURE);
	  }
	free(found_content.dptr);
     }/* done giving 10 questions...now clean up etc. */
   close_database_frommods();
   
   /* update the 'numbers' file,change the value in there put in our current one*/   
   strcpy(num_file_path,data_dir_name);
   strcat(num_file_path,"/numbers");

   if((num_stream = fopen(num_file_path,"w"))==NULL)   /* make a new file */
     {
	beep();
	move(17,10);
	addstr("having trouble opening `numbers'");   /* this bit of code was updated in v1.1 and is untested */
	move(18,10);
	addstr("to update it...giving up");
	refresh();
	exit(EXIT_FAILURE);
     }
   else
     {/*file created,write the text to it and the variable (in text) */
	fprintf(num_stream,"RUNNING_TOTAL %lu \n",running_total);
	fclose(num_stream);
     }   /*done w/ `numbers'*/
   /*done giving test*/
}

unsigned long get_database_size(void)
{
   unsigned long no_of_keys = 0;
   datum key,nextkey;
   char cool = 1;
   /*open the database for reading*/
   open_database_forcheck();
   /*now go thru it*/
   if(!no_of_keys)
     {
	key = gdbm_firstkey(dbfchkvar);
	if(key.dptr!=NULL)/* if there is a first  key, there's  probably a  next, */
	  {
	     do
	       {
		  no_of_keys = no_of_keys + 1;
		  nextkey = gdbm_nextkey(dbfchkvar,key);
		  if(nextkey.dptr==NULL)
		    cool=0;
		  key = nextkey;
	       }
	     while(cool);
	  }
	else
	  no_of_keys = 0;
     }/* okay,we now know how many existing entries (keys)...plus one...there are in the database,we can NOW add stuff after the end  of the database because we now have a numerical handle on that...plus one...*/
   close_database_fromcheck();
   return no_of_keys;
}


void open_database_forcheck(void)
{
   char nouns_file_path[450];
   strcpy(nouns_file_path,data_dir_name);
   strcat(nouns_file_path,"/nouns.spdbf");
   if((dbfchkvar = gdbm_open(nouns_file_path,510,
		      GDBM_READER,0644,0))==NULL)
     {
	move(17,10);
	addstr("could not open the noun database for some reason");
	refresh();
	sleep(2);
	exit(EXIT_FAILURE);
     }

}
void close_database_fromcheck(void)
{
   gdbm_close(dbfchkvar);
}
